*******************************************************************************
*                                                                             *
*              Planar 2 Chunky converter - coded by Trixter/LSD               *
*                                                                             *
*      A software equivilent of the AKIKO without using the OS version!       *
*                                                                             *
*******************************************************************************

pi_width	=	144
pi_height	=	48
pi_nplanes	=	4

pi_bwidth	=	pi_width/8

*******************************************************************************

_frm
		lea	pi_data(pc),a0		; srce = planar image data
		lea	ci_data(pc),a1		; dest = chunky image data
		move.l	#pi_height*pi_bwidth,d0	; size of a source plane
		move.w	#pi_nplanes,d1		; number of planes in source
		bsr.b	convert
		rts


;------------------------------------------------------------------------------
;		Convert a planar image into a chunky one
;
;		a0.l = Pointer to planar image (source)
;		a1.l = Pointer to chunky image (dest)
;		d0.l = Size of one planar plane
;		d1.w = Number of planes in planar image
;------------------------------------------------------------------------------
convert
		move.l	d0,d2			; d2=size of plane (for offset)
.byt
		moveq	#8-1,d3			; initialise cb
.bit
		moveq	#0,d4			; initialise attr
		moveq	#1,d5			; initialise bitp
		move.w	d1,d6			; d6=plane counter
		move.l	a0,a2			; a2=current plane pos
.pln		btst	d3,(a2)			; d3=curr. bit  (a2)=curr. byte
		beq.b	.skp			; if no bit - then no attr bit
		or.b	d5,d4			; d5=bitp d4=attr
.skp		add.w	d5,d5			; next plane bitp
		add.l	d2,a2			; next plane addr
		subq.w	#1,d6			; count to next plane
		bne.b	.pln

		move.b	d4,(a1)+		; save out chunky byte
		dbf	d3,.bit			; do next bit of byte

		addq.l	#1,a0			; next byte in data
		subq.l	#1,d0			; one byte read so dec counter
		bne.b	.byt
		rts


*******************************************************************************
pi_data		incbin	"intro_source:RAW/LSDlogo.RAW"
ci_data		dcb.b	pi_width*pi_height
ci_end
